* Multi-tasking job to change default data size for a file
* (C) 1985 Simon N Goodwin
*
*       Use TABS (Editor) 9,17,25,33,41,49  OR  INTERVAL (Hisoft)  8
*
*		nopage
screensize	equ	8800
screenbase	equ	133300
object_list	equ	$160	        ** 2.3  GG
max_dataspace	equ	850		** 2.2  CD
* sv.ident	  equ	  0	         ** 2.3  GG
sv.ramt		equ	$20	       ** 2.3  GG
sys_com		equ	8+sys_base   Address of address of comms area
	in	win1_lib_hed1

*
		data	8900	Transient window (optional) & A7 stack
*
		bra	start
		dc.b	'23'		Version number
		dc.w	$4AFB
		dc.w	9
		dc.b	'DATASPACE',10
trans_ptr dc.l	0		Flag/address for transient window data
auto_flag dc.w	0		Flag for name taken from video RAM
window		dc.b	4,2		Border
		dc.b	0,7		Paper & Ink
		dc.w	456		Width
		dc.w	64		Height
		dc.w	32		X origin
		dc.w	18		Y origin
backing		dc.b	0,0
		dc.b	228,0
		dc.w	456
		dc.w	64
		dc.w	40
		dc.w	22
heading		dc.w	39
		dc.b	'DATASPACE 2.3  1987 Simon N Goodwin.',10,10
prompt		dc.w	16
		dc.b	'Task file name? '
complaint dc.w	25
		dc.b	'That is not a task file.',10
code_bytes	dc.w	13
		dc.b	' code bytes, '
data_bytes	dc.w	43
		dc.b	' data bytes.',10
		dc.b	'New data size (in Kilobytes) ? '
daft_size dc.w	54
		dc.b	'Size should be between 1K and 850K!',10   ** 2.2
		dc.b	'Please try again: '
new_line		dc.w	1
		dc.b	10
sys_base		ds.l	3	Space for true sys_vars, sys_top
*				& communication area
pe		dc.w	-1	 place for PE 0 = PE
length		dc.w	0
buffer		ds.b	40
header		ds.b	64
		ds.w	10
maths

param_ad	dc.l	0		** 2.2
watermk		dc.w	20		** 2.2
		dc.b	'D.P.:TURBO:INTER-COM'
*
*
inter_com
*	** 2.2		New routine to find Parser intercom area
*			Written	by novice assembler writer
*
*			Object list pointed to by 164192 (long)
*			Each element in	list has +0 (long) ptr to next (0=end)
*					         +4 (long) ptr ident string
*					         +8 data starts
*
*		 move.l	 #object_list,a2
		movea.l	sys_com,a2
i_c_loop		move.l	(a2),a2
		move.l	a2,a0
		bsr	rng_chk
		move.l	4(a2),a0	Ident string for list element
		bsr	rng_chk
		moveq	#21,d0
		lea.l	watermk,a1
w_mk_loop 	cmpm.b	(a1)+,(a0)+	Compare watermark
		bne.s	i_c_loop
		dbra	d0,w_mk_loop
		adda.l	#30,a2
		lea	param_ad,a0
		move.l	a2,(a0)
		rts
rng_chk
		cmpa.l	sys_base,a0
		bls	fatal1	      Bad address - too low
		cmpa.l	sys_base+4,a0
		bhi	fatal1	      Bad address - too high
		rts

fatal1
		moveq.l	#-7,d0		Dummy "not found" error code
		lea	param_ad,a2
		clr.l	(a2)
		addq.l	#4,sp		Pop return stack
		rts
*
** 2.2	addition ends
*


*
* See if there's a valid filename in TURBO/video RAM
*

start		bsr	do_pe		Find if PE and mark it
		moveq	#mt_inf,d0
		trap	#1
		lea	sys_base,a1
		move.l	a0,(a1)+
		move.l	sv.ramt(a0),(a1)+
		lea	object_list(a0),a0
		move.l	a0,(a1)
		moveq	#40,d1		Sensible top name length
		bsr	inter_com 	** 2.2  Locate Turbo intercom area
		move.l	param_ad,a0	** 2.2  CD
		beq.s	check_video	** 2.2  No area found
		tst.w	(a0)+
		bgt.s	check_video	An error count!
		addq.l	#8,a0
		move.w	(a0)+,d0		Report name length
		bmi.s	check_video	Gibberish!
		addq.w	#1,d0		Skip over (even) report name text
		bclr	#0,d0
		adda.w	d0,a0		Implicit EXT
		move.w	(a0)+,d0		Output name length
		beq.s	check_video	Null is ridiculous!
		cmp.w	d1,d0
		bls.s	store_name	Looks very likely
*
check_video	lea.l	140416,a0 	Look in video RAM instead
		tst.w	(a0)+		Check & skip error count
		bne.s	invalid
		addq.l	#4,a0		Skip intermediate-code address
		move.w	(a0)+,d0		Get report length
		cmp.w	d1,d0
		bhi.s	invalid
		addq.w	#1,d0
		bclr	#0,d0
		adda.w	d0,a0		Skip report name
		move.w	(a0)+,d0		Get output file name
		cmp.w	d1,d0
		bhi.s	invalid
		subq.w	#5,d0		Discard Supercharge's '_temp'
		bls.s	invalid
*
store_name	lea.l	auto_flag,a1
		move.w	d0,(a1)		Store length for posterity
		subq.w	#1,d0
		lea.l	buffer,a1
copy_text 	move.b	(a0)+,(a1)+	Copy to buffer before opening window
		dbra	d0,copy_text
*
invalid		adda.l	a6,a4		Get things absolutely right...
		adda.l	a6,a5
		suba.l	a4,a5		A4:=Free dataspace
		cmpa.l	#screensize+100,a5	    Allow room for A7 stack
		blt.s	no_trans
		bsr	scr_ok		Tests that screen is @ $20000
		bne	no_trans
		lea.l	trans_ptr,a5
		move.l	a4,(a5)
		lea.l	screenbase,a5
		move.w	#screensize/4-4,d0
get_scr		move.l	(a5)+,(a4)+
		dbra	d0,get_scr
no_trans		moveq	#-1,d6		Arbitrary silly value
		lea.l	backing,a1
		move.w	$C6,a2
		jsr	(a2)		Open 'background' window
		move.w	pe,d0
		beq	no_close		if PE don't close
		moveq	#2,d0		Then shut it!
		trap	#2
no_close		lea.l	window,a1 	Open the real window (giving
		move.w	$C6,a2		a trendy shaded '3D' effect)
		jsr	(a2)
		moveq	#2,d1		Width 2
		moveq	#0,d2		Height 1
		moveq	#-1,d3
		moveq	#$2D,d0		Set CSIZE
		trap	#3
		move.l	a0,d7		Save channel ID
		lea.l	heading,a1
		bsr.s	short_print
say_hi		lea.l	prompt,a1
		bsr.s	short_print	Prompt the user
		lea.l	auto_flag,a1
		move.w	(a1),d5
		beq.s	manual
		clr.w	(a1)		Only one AUTO allowed
		lea.l	length,a1
		move.w	d5,(a1)		Set length for string
		bsr.s	short_print	Print the assumed name
		lea.l	new_line,a1
		bsr.s	short_print
		move.w	d5,d1		Set up length
		bra.s	automatic
manual		bsr	input
automatic 	lea.l	length,a0
		move.w	d1,(a0)		Store length
		moveq	#0,d3		Open exclusive
		moveq	#-1,d1		Job ID=myself
		moveq	#1,d0
		trap	#2		Try to open 'name'
		tst.l	d0		Success?
		beq.s	got_file
error		move.l	d7,a0		Retrieve console ID
		move.w	$CC,a2
		jsr	(a2)		Issue error message
		bra.s	say_hi
short_print	bra	print
got_file	move.l	a0,d6		Save file ID
		moveq	#64,d2		Buffer size
		moveq	#-1,d3		Be patient
		lea.l	header,a1
		moveq	#$47,d0
		trap	#3		Read header
		tst.l	d0
		bne	shut_up
		lea.l	header+5,a2
		tst.b	(a2)		Check type
		bne.s	exec_type
		lea.l	complaint,a1
		bsr.s	short_print
		bra	try_again
exec_type move.l	header,d1 Print details
		bsr	print_d1
		lea.l	code_bytes,a1
		bsr.s	short_print
		move.l	header+6,d1
		bsr	print_d1
		lea.l	data_bytes,a1
		bsr.s	short_print
ask_size	bsr	input
		lea.l	buffer,a0
		suba.l	a6,a0		Start pointer
		move.l	d7,d5		Musical registers!
		move.l	a0,d7
		ext.l	d1
		add.l	d1,d7		End pointer
*
* Discard any 'K' that may be at the end of the text
*
		move.b	-1(a6,d7.l),d1
		cmp.b	#'K',d1
		bcs.s	not_k
		subq.l	#1,d7
not_k		lea.l	maths-10,a1
		suba.l	a6,a1		Maths SP
		move.w	$102,a2
		jsr	(a2)		Convert to INT
		move.l	d5,d7		Tidy up QUICK!
		tst.l	d0
		bne.s	shut_up
		move.w	0(a1,a6.l),d0
		ble.s	antisize
		cmp.w	#max_dataspace+1,d0     Check size
		bcs.s	size_ok
antisize		lea.l	daft_size,a1
		bsr	print
		bra.s	ask_size
size_ok		mulu	#1024,d0	Convert to K
		lea.l	header+6,a0
		move.l	d0,(a0)	Store new size
		move.l	d6,a0		Retrieve file ID
		lea.l	header,a1
		moveq	#-1,d3		Don't timeout
		moveq	#$46,d0
		trap	#3		Rewrite header
		tst.l	d0		Success?
		bne.s	shut_up
try_again move.l	d6,a0
		moveq	#2,d0
		trap	#2		Close the file
		bra	say_hi		Ask for another
shut_up		move.l	d6,a0
		move.l	d0,d6
		moveq	#2,d0
		trap	#2
		move.l	d6,d0
		bra	error
*
scr_ok:		bsr	ope
		bne	scr_ok1
		moveq	#-1,d3
		lea	scr_b,a2
		moveq	#sd_extop,d0
		trap	#3
		move.l	d0,d7
		move.l	a1,d6
		moveq	#io_close,d0
		trap	#2
		tst.l	d7
		bne	scr_ok1
		cmp.l	#$20000,d6
scr_ok1		rts
*
scr_b		movea.l	$32(a0),a1	screen base
		moveq	#0,d0
		rts
*
ope		lea	scr,a0
		moveq	#-1,d1
		moveq	#0,d3
		moveq	#io_open,d0
		trap	#2
		tst.l	d0
		rts
*
		hed1	"scr",scr
*
do_pe		bsr	ope
		bne	do_pe1
		moveq	#-1,d3
		moveq	#$70,d0
		trap	#3
		move.l	d0,d7
		moveq	#io_close,d0
		trap	#2
		move.l	d7,d0
do_pe1		lea	pe,a1
		move.w	d0,(a1)
		rts
*
exit		moveq	#2,d0
		move.l	d6,a0		Close file
		bmi.s	no_file
		trap	#2
no_file		move.l	d7,a0
		moveq	#50,d3		Allow 1 second
		moveq	#32,d0		to clear window
		trap	#3
		moveq	#io_close,d0	** Was missing!! **
		trap	#2		then close it
		move.l	trans_ptr,d0
		beq.s	not_trans
		move.l	d0,a5
		lea.l	screenbase,a4
		move.w	#screensize/4-4,d0
put_scr		move.l	(a5)+,(a4)+
		dbra	d0,put_scr
not_trans moveq	#5,d0
		moveq	#-1,d1
		trap	#1		Commit suicide
*
input		moveq	#40,d2
		moveq	#-1,d3		Infinite patience
		lea.l	buffer,a1
		moveq	#2,d0
		trap	#3		Read line
		tst.l	d0
		bne.s	input
		subq	#1,d1		Ignore terminator
		beq.s	exit		Null - so stop
		rts
*
print_d1	lea.l	maths,a1
		suba.l	a6,a1
		subq.l	#6,a1
		moveq	#0,d2
		tst.l	d1
		beq.s	zero
		move.w	#$820,d2	Abnormal (?) exponent
shift		subq.w	#1,d2		Normalise a bit
		lsl.l	#1,d1		Make mantissa match
		bpl.s	shift
		lsr.l	#1,d1		Retrieve the top bit
zero		move.w	d2,0(a1,a6.l)
		move.l	d1,2(a1,a6.l)
		lea.l	buffer,a0
		suba.l	a6,a0		Relative pointer
		move.w	$F0,a2
		jsr	(a2)		Convert to text
		lea.l	length,a1
		move.w	d1,(a1)
print		move.l	d7,a0
		move.w	$D0,a2		Call UT.MTEXT
		jmp	(a2)		Fall in
*
		end
